/*
 * CCVisu is a tool for visual graph clustering
 * and general force-directed graph layout.
 * This file is part of CCVisu.
 *
 * Copyright (C) 2005-2012  Dirk Beyer
 *
 * CCVisu is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * CCVisu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with CCVisu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Please find the GNU Lesser General Public License in file
 * license_lgpl.txt or http://www.gnu.org/licenses/lgpl.txt
 *
 * Dirk Beyer    (firstname.lastname@uni-passau.de)
 * University of Passau, Bavaria, Germany
 */
package org.sosy_lab.ccvisu.writers;

import java.io.PrintWriter;

import org.sosy_lab.ccvisu.Options;
import org.sosy_lab.ccvisu.graph.GraphData;
import org.sosy_lab.ccvisu.graph.GraphEdge;
import org.sosy_lab.ccvisu.graph.GraphVertex;

/**
 * Writer for graphs in GraphML format.
 */
public class WriterDataGraphGML extends WriterData {

  public WriterDataGraphGML(PrintWriter out, GraphData graph) {
    super(out, graph);
  }

  /**
   * Writes the graph data in RSF (relational standard format).
   */
  @Override
  public void write() {
    // Header
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>");
    out.println("<!-- Generated by " + Options.toolDescription() + " -->"
                + WriterData.endl + "<!-- " + Options.currentDateTime()
                + " -->");

    out.println("<graphml xmlns=\"http://graphml.graphdrawing.org/xmlns/graphml\" "
                 + "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
                 + "xsi:schemaLocation=\"http://graphml.graphdrawing.org/xmlns/graphml "
                 + "http://graphml.graphdrawing.org/xmlns/graphml/graphml-attributes-1.0rc.xsd\" >");

    out.println("<key attr.name=\".graphics.fillcolor.transparency\" attr.type=\"int\" for=\"node\" id=\"na12\"/>");
    out.println("<key attr.name=\".graphics.fillcolor.red\" attr.type=\"int\" for=\"node\" id=\"na13\"/>");
    out.println("<key attr.name=\".graphics.fillcolor.blue\" attr.type=\"int\" for=\"node\" id=\"na14\"/>");
    out.println("<key attr.name=\".graphics.fillcolor.green\" attr.type=\"int\" for=\"node\" id=\"na15\"/>");

    out.println("<graph edgedefault=\"directed\" id=\"G\">");

    // Vertices
    for (GraphVertex vertex : graph.getVertices()) {
      out.println("<node id=\"n" + vertex.getName() + "\">");
      out.println("<data key=\"na13\">" + vertex.getColor().getRed() + "</data>");
      out.println("<data key=\"na14\">" + vertex.getColor().getBlue() + "</data>");
      out.println("<data key=\"na15\">" + vertex.getColor().getGreen() + "</data>");
      out.println("</node>");
    }

    // Edges
    for (GraphEdge edge : graph.getEdges()) {
      out.println("<edge id=\"en" + edge.getSource().getName()
          + "n" + edge.getTarget().getName() + "\" "
          + "source=\"n" + edge.getSource().getName() + "\" "
          + "target=\"n" + edge.getTarget().getName() + "\"></edge>");
    }

    // Footer
    out.println("</graph>");
    out.println("</graphml>");

    out.flush();
  }
}
